import os
os.environ['DJANGO_SETTINGS_MODULE'] = "metastate.settings"
#import metastate
import sys
sys.path.append("/home/wizard23/metasense")

from metastate.activity.models import *
import time
from datetime import datetime, timedelta
from pychart import *
from time_offset import time_correct

def get_seconds(dt):
    return time.mktime(dt.timetuple())

def format_date(t):
    return "/a10{}"+datetime.fromtimestamp(t).strftime('%H:%M')

def avg_plot(dbName, dbDate, niceName, fileName, days=10, ytic=20, yrange=None):
	timeSlots = []
	timeSlotsCount = []
	slots = 240/2
	
	niceName += " average last %d days" % days
	
	for i in range(0, slots):
		timeSlots.append(0)
		timeSlotsCount.append(0)
	
	oneDay = timedelta(days = 1)
	slotLen = oneDay / slots
	
	for currentDay in range(-days, 1):
		start = dbDate + oneDay*currentDay 
		end = start + oneDay
	
		startSec = get_seconds(start)
		endSec = get_seconds(end)
		intervalLen = endSec - startSec
	
		dbLoc = Location.objects.get(description=dbName)
		activities = Activity.objects.filter(timestamp__gte=start, timestamp__lte=end, location=dbLoc.id).order_by('timestamp')
	
		print "day: %d activities: %d" % (currentDay, len(activities))
		
		for a in activities:
			idx = int(((get_seconds(a.timestamp) - startSec)*slots) / intervalLen)
			timeSlots[idx] += a.activity
			timeSlotsCount[idx] += 1
		
	plotData = []
	print timeSlots
	print timeSlotsCount
	
	currentDate = start
	for idx in range(0, slots):
		if timeSlotsCount[idx] > 0:
			plotData.append((get_seconds(currentDate), timeSlots[idx]/timeSlotsCount[idx]))
		else:
			plotData.append((get_seconds(currentDate), 0))
		currentDate += slotLen
		
	print "Plotting average %s for the last %d days" % (niceName, days)

	dateFormat = '%Y.%m.%d'
	xlabel = "%s: %s - %s" % (niceName, (dbDate-days*oneDay).strftime(dateFormat), dbDate.strftime(dateFormat))
	xaxis = axis.X(label=xlabel, tic_interval=3600, format=format_date)
	yaxis = axis.Y(label="Nerd Activity", tic_interval = ytic)
	ar = area.T(size=(800, 80), legend=None, x_axis=xaxis, y_axis=yaxis, y_range=(0, yrange), x_range=(get_seconds(start), get_seconds(end)))
	
	if len(plotData) > 0:
		plot = bar_plot.T(label=None, data=plotData, width=4, fill_style = fill_style.black) #fill_style.green)
		ar.add_plot(plot)
	
	can = canvas.init("/var/www/kybernet.org/wizard23/metasense/%s" % fileName, "png")
	ar.draw(can)
	can.close()
		
		
		
	 

def day_plot(dbName, niceName, fileName, ytic=20, yrange=None):
	now = datetime.now()
	#now = now - timedelta(minutes=now.min, seconds=now.second)
	yesterday = now-timedelta(days=1, minutes=now.minute, seconds=now.second)
	dbLoc = Location.objects.get(description=dbName)
	recentActivities = Activity.objects.filter(timestamp__gte=yesterday, location=dbLoc.id).order_by('timestamp')

	missingData = []
	plotData = []
	timePos = yesterday
	maxErr = 300
	
	for a in recentActivities:
		plotData.append((get_seconds(a.timestamp), a.activity))
		x = a.timestamp - timePos
		
		while x.seconds > maxErr:
			missingData.append((get_seconds(timePos), 255))
			timePos += timedelta(seconds=maxErr)
			x = a.timestamp - timePos
			
		timePos = a.timestamp
		
	x = now - timePos
	while x.seconds > maxErr:
		missingData.append((get_seconds(timePos), 255))
		timePos += timedelta(seconds=maxErr)
		x = now - timePos

	print "Plotting %s with %d data points and %d missings" % (niceName, len(plotData), len(missingData))

	dateFormat = '%Y.%m.%d %H:%M'
	xlabel = "%s: %s - %s" % (niceName, yesterday.strftime(dateFormat), now.strftime(dateFormat))
	xaxis = axis.X(label=xlabel, tic_interval=3600, format=format_date)
	yaxis = axis.Y(label="Nerd Activity", tic_interval = ytic)
	ar = area.T(size=(800, 80), legend=None, x_axis=xaxis, y_axis=yaxis, y_range=(0, yrange), x_range=(get_seconds(yesterday), get_seconds(now)))
	
	#fill_style.T(
	#color.T(r=1, g=0, b=1)
	if len(missingData) > 0:
		plot = bar_plot.T(label=None, data=missingData, width = 2, fill_style=fill_style.horiz, line_style=None)
		ar.add_plot(plot)
	
	if len(plotData) > 0:
		plot = bar_plot.T(label=None, data=plotData, width=1, fill_style = None) #fill_style.green)
		ar.add_plot(plot)
	
	
	can = canvas.init("/var/www/kybernet.org/wizard23/metasense/%s" % fileName, "png")
	ar.draw(can)
	can.close()
	
def day_mini_plot(dbName, niceName, fileName, ytic=20, yrange=None):
	now = datetime.now()
	yesterday = now-timedelta(days=1)
	dbLoc = Location.objects.get(description=dbName)
	recentActivities = Activity.objects.filter(timestamp__gte=yesterday, location=dbLoc.id).order_by('timestamp')

	#dirty time bug fix
	now += time_correct
	yesterday += time_correct

	plotData = []
	for a in recentActivities:
		plotData.append((get_seconds(a.timestamp+time_correct), a.activity))

	print "Plotting %d data points" % len(plotData)

	dateFormat = '%Y.%m.%d %H:%M'
	xlabel = "%s: %s - %s" % (niceName, yesterday.strftime(dateFormat), now.strftime(dateFormat))
	xaxis = axis.X(label=None, tic_interval=3600, format=format_date)
	yaxis = axis.Y(label="Nerd Activity", tic_interval = ytic)
	ar = area.T(size=(800, 60), legend=None, x_axis=xaxis, y_axis=yaxis, y_range=(0, yrange), x_range=(get_seconds(yesterday), get_seconds(now)))
	plot = bar_plot.T(label=None, data=plotData)#, ycol=1)
	ar.add_plot(plot)
	can = canvas.init("/var/www/kybernet.org/wizard23/metasense/%s" % fileName, "png")
	ar.draw(can)
	can.close()

webdir = "/var/www/kybernet.org/wizard23/metasense/"

def update_status_led():
	loc_lock = Location.objects.get(description="door_lock")
	moment_ago = datetime.now()-timedelta(minutes=5)
	lockActivities = Activity.objects.filter(timestamp__gte=moment_ago, location=loc_lock.id).order_by('timestamp')
	if len(lockActivities) == 0:
		os.system("cp %simages/M_black.gif %smetalab_lock.gif" % (webdir, webdir))
	elif lockActivities[len(lockActivities)-1].activity == 0:
		os.system("cp %simages/M_green.gif %smetalab_lock.gif" % (webdir, webdir))
	else:
		os.system("cp %simages/M_red.gif %smetalab_lock.gif" % (webdir, webdir))
		
		
#acts = Activity.objects.all()
#aold = acts[179]
#for a in acts[180:199]:
#	x = aold.timestamp - a.timestamp
#	print x.seconds
#	aold = a
#sys.exit()


#update_status_led()
#day_plot("mainroom_move1", "Main Room Movement", "metalab_activity.png", yrange=100)
#day_plot("door_lock", "Lock Status", "metalab_lock_activity.png", 256)
#day_plot("kitchen_move", "Kitchen Movement", "metalab_kitchen_activity.png", yrange=100)

now =  datetime.now()
startOfToday = now-timedelta(hours=now.hour, minutes=now.minute, seconds=now.second)
avg_plot("mainroom_move1", startOfToday, "Main Room Movement", "metalab_activity_avg.png", days=10, yrange=50)
avg_plot("door_lock", startOfToday, "LockStatus", "metalab_lock_activity_avg.png", days=10, ytic=256, yrange=256)
avg_plot("kitchen_move", startOfToday, "Kitchen Movement", "metalab_kitchen_activity_avg.png", days=10, yrange=50)



#day_mini_plot("mainroom_move1", "Main Room Movement", "metalab_activity_mini.png", ytic=25, yrange=100)

    
    
